<%@page import="com.fatwire.cs.ui.framework.UIException"
%><%@page import="com.fatwire.ui.util.GenericUtil"
%><%@ taglib prefix="cs" uri="futuretense_cs/ftcs1_0.tld"
%><%@ taglib prefix="controller" uri="futuretense_cs/controller.tld"
%><%@ taglib prefix="xlat" uri="futuretense_cs/xlat.tld"
%><%@ page import="org.apache.commons.lang.StringEscapeUtils"
%><cs:ftcs><%
try {
	// change the url passed to buildControllerURL() as per the location of RecentlyModifiedAssetsAction
	String storeUrl = GenericUtil.buildControllerURL("UI/Layout/CenterPane/DashBoard/RecentlyModifiedAssets", GenericUtil.JSON);
%>

<script>


	dojo.unsubscribe(myContextMenuSubscription);

	// listening to bookmarkcontext menu right click event
	var myContextMenuSubscription = dojo.subscribe("fw/ui/dashboard/mycontextmenu",  "myContextMenu");

	function myContextMenu(args){
		//Summary
		//		this function publishes dojo topic '/fw/ui/app/oncontext' with specified function id and asset data.
		// args
		//		{label: 'label', functionid: 'functionId'}
		var assetData = getSelectedAsset();
		// publish the generic 'oncontext' event
		dojo.publish('/fw/ui/app/oncontext', [{functionid: args.functionid, asset:assetData}]);
	}
	
	function getSelectedAsset(){
		//Summary
		//		This method returns the selected asset from the grid
		//returns 
		//		asset{type:assetType, id:assetId, name:assetName}
		var grid = dijit.byId("myGridId");
		var asset, store, item;
		if(grid){
			// get the selected items, we are interested in first item
			items = grid.selection.getSelected();
			if(items && items.length == 1){
				store = grid.store;
				item = items[0];
				if(item && store) {
					// get the selected asset
					asset = {
						"type": store.getValue(item, 'type'),
						"id": store.getValue(item, 'id'),
						"name": store.getValue(item, 'name')
					};
				}
			}
			else{
				fw.ui.app.displayMessage("No assets selected.", "warn");
				return;
			}
		}	
		return asset;
	}
	
	function refreshRecentAssets(){
		//summary 
		//		This method fetches the assets and builds grid's store and refreshes the grid.
		var grid = dijit.byId("myGridId");
		if(grid){
			store = new dojo.data.ItemFileReadStore({
				url: '<%=storeUrl%>'
			});
			// reset the store for the grid and refresh
			if (grid.store) {
				grid.store.close();
			}
			grid.setStore(store);
			//startup grid after the store set.
			grid.startup();
			grid._refresh();
			grid.selection.deselectAll();
		}
	}
	
</script>

<%-- build the context menu --%>
<controller:callelement elementname="UI/Layout/CenterPane/Search/View/ContextMenu">
	<controller:argument name="menuId" value="myMenuId" />
	<controller:argument name="configName" value="UI/Layout/CenterPane/DashBoard/ContextMenuConfig"/>
	<controller:argument name="topic" value="fw/ui/dashboard/mycontextmenu" /> 
</controller:callelement>

<div data-dojo-type="dijit.layout.BorderContainer" data-dojo-props="'class':'fwPortletContainer'">
	<span data-dojo-type="dijit.layout.ContentPane" data-dojo-props="region:'top','class':'portletTitleButtons'">		
		<span 
			data-dojo-type="dijit.form.Button"
			data-dojo-props="
				onClick: function() {
					refreshRecentAssets();
				}
			">
			<img src="wemresources/images/ui/ui/dashboard/refreshIcon.png" height="26" width="26" alt="" title=""/>
		</span>		
	</span>
	
	<div data-dojo-type="dijit.layout.ContentPane" data-dojo-props="region:'center','class':'fwGridContainer'">	
		<!-- Build Grid -->	
		<controller:callelement elementname="UI/Layout/Utils/Grid">
			<controller:argument name="configName" value="UI/Layout/Utils/GridConfig"/>
			<controller:argument name="storeURL" value="<%=storeUrl%>" />
			<controller:argument name="storeId" value="myStoreId"/>
			<controller:argument name="storeType" value="dojo.data.ItemFileReadStore" />
			<controller:argument name="gridId" value="myGridId" />
			<controller:argument name="contextMenuId" value="myMenuId"/>
			<!-- possible values of selection mode are 'none', 'single', 'multiple' and 'extended' -->
			<controller:argument name="selectionMode" value="single"/>
		</controller:callelement>
		<div class="buttonContainer">
			<div 
				data-dojo-type="fw.ui.dijit.Button"
				data-dojo-props="
					label:'Refresh',
					onClick: function() {
						refreshRecentAssets();
					}
				">
			</div>
		</div>	
	</div>
	
</div>
<%
} catch(Exception e) {
	UIException uie = new UIException(e);
	request.setAttribute(UIException._UI_EXCEPTION_, uie);
	throw uie;
}%>
</cs:ftcs>